Package org.apache.commons.lang3.text

## Class StrBuilder

- java.lang.Object
- - org.apache.commons.lang3.text.StrBuilder

All Implemented Interfaces:
  `java.io.Serializable`, `java.lang.Appendable`, `java.lang.CharSequence`, `Builder<java.lang.String>`

    @Deprecated
    public class StrBuilder
    extends java.lang.Object
    implements java.lang.CharSequence, java.lang.Appendable, java.io.Serializable, Builder<java.lang.String>

Deprecated.
as of 3.6, use commons-text TextStringBuilder instead
Builds a string from constituent parts providing a more flexible and powerful API than StringBuffer.

The main differences from StringBuffer/StringBuilder are:

- Not synchronized
- Not final
- Subclasses have direct access to character array
- Additional methods
  - appendWithSeparators - adds an array of values, with a separator
  - appendPadding - adds a length padding characters
  - appendFixedLength - adds a fixed width field to the builder
  - toCharArray/getChars - simpler ways to get a range of the character array
  - delete - delete char or string
  - replace - search and replace for a char or string
  - leftString/rightString/midString - substring without exceptions
  - contains - whether the builder contains a char or string
  - size/clear/isEmpty - collections style API methods
- Views
  - asTokenizer - uses the internal buffer as the source of a StrTokenizer
  - asReader - uses the internal buffer as the source of a Reader
  - asWriter - allows a Writer to write directly to the internal buffer

The aim has been to provide an API that mimics very closely what StringBuffer provides, but with additional methods. It should be noted that some edge cases, with invalid indices or null input, have been altered - see individual methods. The biggest of these changes is that by default, null will not output the text 'null'. This can be controlled by a property, `setNullText(String)`.

Prior to 3.0, this class implemented Cloneable but did not implement the clone method so could not be used. From 3.0 onwards it no longer implements the interface.

Since:
  2.2
See Also:
  Serialized Form

### Field Summary

Fields
`protected char[]` `buffer` Deprecated. Internal data storage.
`protected int` `size` Deprecated. Current size of the buffer.

### Constructor Summary

Constructors
`StrBuilder()` Deprecated. Constructor that creates an empty builder initial capacity 32 characters.
`StrBuilder​(int initialCapacity)` Deprecated. Constructor that creates an empty builder the specified initial capacity.
`StrBuilder​(java.lang.String str)` Deprecated. Constructor that creates a builder from the string, allocating 32 extra characters for growth.

### Method Summary

All Methods Instance Methods Concrete Methods Deprecated Methods
`StrBuilder` `append​(boolean value)` Deprecated. Appends a boolean value to the string builder.
`StrBuilder` `append​(char ch)` Deprecated. Appends a char value to the string builder.
`StrBuilder` `append​(char[] chars)` Deprecated. Appends a char array to the string builder.
`StrBuilder` `append​(char[] chars, int startIndex, int length)` Deprecated. Appends a char array to the string builder.
`StrBuilder` `append​(double value)` Deprecated. Appends a double value to the string builder using `String.valueOf`.
`StrBuilder` `append​(float value)` Deprecated. Appends a float value to the string builder using `String.valueOf`.
`StrBuilder` `append​(int value)` Deprecated. Appends an int value to the string builder using `String.valueOf`.
`StrBuilder` `append​(long value)` Deprecated. Appends a long value to the string builder using `String.valueOf`.
`StrBuilder` `append​(java.lang.CharSequence seq)` Deprecated. Appends a CharSequence to this string builder.
`StrBuilder` `append​(java.lang.CharSequence seq, int startIndex, int length)` Deprecated. Appends part of a CharSequence to this string builder.
`StrBuilder` `append​(java.lang.Object obj)` Deprecated. Appends an object to this string builder.
`StrBuilder` `append​(java.lang.String str)` Deprecated. Appends a string to this string builder.
`StrBuilder` `append​(java.lang.StringBuffer str)` Deprecated. Appends a string buffer to this string builder.
`StrBuilder` `append​(java.lang.StringBuffer str, int startIndex, int length)` Deprecated. Appends part of a string buffer to this string builder.
`StrBuilder` `append​(java.lang.StringBuilder str)` Deprecated. Appends a StringBuilder to this string builder.
`StrBuilder` `append​(java.lang.StringBuilder str, int startIndex, int length)` Deprecated. Appends part of a StringBuilder to this string builder.
`StrBuilder` `append​(java.lang.String str, int startIndex, int length)` Deprecated. Appends part of a string to this string builder.
`StrBuilder` `append​(java.lang.String format, java.lang.Object... objs)` Deprecated. Calls `String.format(String, Object...)` and appends the result.
`StrBuilder` `append​(java.nio.CharBuffer buf)` Deprecated. Appends the contents of a char buffer to this string builder.
`StrBuilder` `append​(java.nio.CharBuffer buf, int startIndex, int length)` Deprecated. Appends the contents of a char buffer to this string builder.
`StrBuilder` `append​(StrBuilder str)` Deprecated. Appends another string builder to this string builder.
`StrBuilder` `append​(StrBuilder str, int startIndex, int length)` Deprecated. Appends part of a string builder to this string builder.
`StrBuilder` `appendAll​(java.lang.Iterable<?> iterable)` Deprecated. Appends each item in an iterable to the builder without any separators.
`StrBuilder` `appendAll​(java.util.Iterator<?> it)` Deprecated. Appends each item in an iterator to the builder without any separators.
`<T> StrBuilder` `appendAll​(T... array)` Deprecated. Appends each item in an array to the builder without any separators.
`StrBuilder` `appendFixedWidthPadLeft​(int value, int width, char padChar)` Deprecated. Appends an object to the builder padding on the left to a fixed width.
`StrBuilder` `appendFixedWidthPadLeft​(java.lang.Object obj, int width, char padChar)` Deprecated. Appends an object to the builder padding on the left to a fixed width.
`StrBuilder` `appendFixedWidthPadRight​(int value, int width, char padChar)` Deprecated. Appends an object to the builder padding on the right to a fixed length.
`StrBuilder` `appendFixedWidthPadRight​(java.lang.Object obj, int width, char padChar)` Deprecated. Appends an object to the builder padding on the right to a fixed length.
`StrBuilder` `appendln​(boolean value)` Deprecated. Appends a boolean value followed by a new line to the string builder.
`StrBuilder` `appendln​(char ch)` Deprecated. Appends a char value followed by a new line to the string builder.
`StrBuilder` `appendln​(char[] chars)` Deprecated. Appends a char array followed by a new line to the string builder.
`StrBuilder` `appendln​(char[] chars, int startIndex, int length)` Deprecated. Appends a char array followed by a new line to the string builder.
`StrBuilder` `appendln​(double value)` Deprecated. Appends a double value followed by a new line to the string builder using `String.valueOf`.
`StrBuilder` `appendln​(float value)` Deprecated. Appends a float value followed by a new line to the string builder using `String.valueOf`.
`StrBuilder` `appendln​(int value)` Deprecated. Appends an int value followed by a new line to the string builder using `String.valueOf`.
`StrBuilder` `appendln​(long value)` Deprecated. Appends a long value followed by a new line to the string builder using `String.valueOf`.
`StrBuilder` `appendln​(java.lang.Object obj)` Deprecated. Appends an object followed by a new line to this string builder.
`StrBuilder` `appendln​(java.lang.String str)` Deprecated. Appends a string followed by a new line to this string builder.
`StrBuilder` `appendln​(java.lang.StringBuffer str)` Deprecated. Appends a string buffer followed by a new line to this string builder.
`StrBuilder` `appendln​(java.lang.StringBuffer str, int startIndex, int length)` Deprecated. Appends part of a string buffer followed by a new line to this string builder.
`StrBuilder` `appendln​(java.lang.StringBuilder str)` Deprecated. Appends a string builder followed by a new line to this string builder.
`StrBuilder` `appendln​(java.lang.StringBuilder str, int startIndex, int length)` Deprecated. Appends part of a string builder followed by a new line to this string builder.
`StrBuilder` `appendln​(java.lang.String str, int startIndex, int length)` Deprecated. Appends part of a string followed by a new line to this string builder.
`StrBuilder` `appendln​(java.lang.String format, java.lang.Object... objs)` Deprecated. Calls `String.format(String, Object...)` and appends the result.
`StrBuilder` `appendln​(StrBuilder str)` Deprecated. Appends another string builder followed by a new line to this string builder.
`StrBuilder` `appendln​(StrBuilder str, int startIndex, int length)` Deprecated. Appends part of a string builder followed by a new line to this string builder.
`StrBuilder` `appendNewLine()` Deprecated. Appends the new line string to this string builder.
`StrBuilder` `appendNull()` Deprecated. Appends the text representing `null` to this string builder.
`StrBuilder` `appendPadding​(int length, char padChar)` Deprecated. Appends the pad character to the builder the specified number of times.
`StrBuilder` `appendSeparator​(char separator)` Deprecated. Appends a separator if the builder is currently non-empty.
`StrBuilder` `appendSeparator​(char standard, char defaultIfEmpty)` Deprecated. Append one of both separators to the builder If the builder is currently empty it will append the defaultIfEmpty-separator Otherwise it will append the standard-separator The separator is appended using `append(char)`.
`StrBuilder` `appendSeparator​(char separator, int loopIndex)` Deprecated. Appends a separator to the builder if the loop index is greater than zero.
`StrBuilder` `appendSeparator​(java.lang.String separator)` Deprecated. Appends a separator if the builder is currently non-empty.
`StrBuilder` `appendSeparator​(java.lang.String separator, int loopIndex)` Deprecated. Appends a separator to the builder if the loop index is greater than zero.
`StrBuilder` `appendSeparator​(java.lang.String standard, java.lang.String defaultIfEmpty)` Deprecated. Appends one of both separators to the StrBuilder.
`void` `appendTo​(java.lang.Appendable appendable)` Deprecated. Appends current contents of this `StrBuilder` to the provided `Appendable`.
`StrBuilder` `appendWithSeparators​(java.lang.Iterable<?> iterable, java.lang.String separator)` Deprecated. Appends an iterable placing separators between each value, but not before the first or after the last.
`StrBuilder` `appendWithSeparators​(java.lang.Object[] array, java.lang.String separator)` Deprecated. Appends an array placing separators between each value, but not before the first or after the last.
`StrBuilder` `appendWithSeparators​(java.util.Iterator<?> it, java.lang.String separator)` Deprecated. Appends an iterator placing separators between each value, but not before the first or after the last.
`java.io.Reader` `asReader()` Deprecated. Gets the contents of this builder as a Reader.
`StrTokenizer` `asTokenizer()` Deprecated. Creates a tokenizer that can tokenize the contents of this builder.
`java.io.Writer` `asWriter()` Deprecated. Gets this builder as a Writer that can be written to.
`java.lang.String` `build()` Deprecated. Implement the `Builder` interface.
`int` `capacity()` Deprecated. Gets the current size of the internal character array buffer.
`char` `charAt​(int index)` Deprecated. Gets the character at the specified index.
`StrBuilder` `clear()` Deprecated. Clears the string builder (convenience Collections API style method).
`boolean` `contains​(char ch)` Deprecated. Checks if the string builder contains the specified char.
`boolean` `contains​(java.lang.String str)` Deprecated. Checks if the string builder contains the specified string.
`boolean` `contains​(StrMatcher matcher)` Deprecated. Checks if the string builder contains a string matched using the specified matcher.
`StrBuilder` `delete​(int startIndex, int endIndex)` Deprecated. Deletes the characters between the two specified indices.
`StrBuilder` `deleteAll​(char ch)` Deprecated. Deletes the character wherever it occurs in the builder.
`StrBuilder` `deleteAll​(java.lang.String str)` Deprecated. Deletes the string wherever it occurs in the builder.
`StrBuilder` `deleteAll​(StrMatcher matcher)` Deprecated. Deletes all parts of the builder that the matcher matches.
`StrBuilder` `deleteCharAt​(int index)` Deprecated. Deletes the character at the specified index.
`StrBuilder` `deleteFirst​(char ch)` Deprecated. Deletes the character wherever it occurs in the builder.
`StrBuilder` `deleteFirst​(java.lang.String str)` Deprecated. Deletes the string wherever it occurs in the builder.
`StrBuilder` `deleteFirst​(StrMatcher matcher)` Deprecated. Deletes the first match within the builder using the specified matcher.
`boolean` `endsWith​(java.lang.String str)` Deprecated. Checks whether this builder ends with the specified string.
`StrBuilder` `ensureCapacity​(int capacity)` Deprecated. Checks the capacity and ensures that it is at least the size specified.
`boolean` `equals​(java.lang.Object obj)` Deprecated. Checks the contents of this builder against another to see if they contain the same character content.
`boolean` `equals​(StrBuilder other)` Deprecated. Checks the contents of this builder against another to see if they contain the same character content.
`boolean` `equalsIgnoreCase​(StrBuilder other)` Deprecated. Checks the contents of this builder against another to see if they contain the same character content ignoring case.
`char[]` `getChars​(char[] destination)` Deprecated. Copies the character array into the specified array.
`void` `getChars​(int startIndex, int endIndex, char[] destination, int destinationIndex)` Deprecated. Copies the character array into the specified array.
`java.lang.String` `getNewLineText()` Deprecated. Gets the text to be appended when a new line is added.
`java.lang.String` `getNullText()` Deprecated. Gets the text to be appended when null is added.
`int` `hashCode()` Deprecated. Gets a suitable hash code for this builder.
`int` `indexOf​(char ch)` Deprecated. Searches the string builder to find the first reference to the specified char.
`int` `indexOf​(char ch, int startIndex)` Deprecated. Searches the string builder to find the first reference to the specified char.
`int` `indexOf​(java.lang.String str)` Deprecated. Searches the string builder to find the first reference to the specified string.
`int` `indexOf​(java.lang.String str, int startIndex)` Deprecated. Searches the string builder to find the first reference to the specified string starting searching from the given index.
`int` `indexOf​(StrMatcher matcher)` Deprecated. Searches the string builder using the matcher to find the first match.
`int` `indexOf​(StrMatcher matcher, int startIndex)` Deprecated. Searches the string builder using the matcher to find the first match searching from the given index.
`StrBuilder` `insert​(int index, boolean value)` Deprecated. Inserts the value into this builder.
`StrBuilder` `insert​(int index, char value)` Deprecated. Inserts the value into this builder.
`StrBuilder` `insert​(int index, char[] chars)` Deprecated. Inserts the character array into this builder.
`StrBuilder` `insert​(int index, char[] chars, int offset, int length)` Deprecated. Inserts part of the character array into this builder.
`StrBuilder` `insert​(int index, double value)` Deprecated. Inserts the value into this builder.
`StrBuilder` `insert​(int index, float value)` Deprecated. Inserts the value into this builder.
`StrBuilder` `insert​(int index, int value)` Deprecated. Inserts the value into this builder.
`StrBuilder` `insert​(int index, long value)` Deprecated. Inserts the value into this builder.
`StrBuilder` `insert​(int index, java.lang.Object obj)` Deprecated. Inserts the string representation of an object into this builder.
`StrBuilder` `insert​(int index, java.lang.String str)` Deprecated. Inserts the string into this builder.
`boolean` `isEmpty()` Deprecated. Checks is the string builder is empty (convenience Collections API style method).
`int` `lastIndexOf​(char ch)` Deprecated. Searches the string builder to find the last reference to the specified char.
`int` `lastIndexOf​(char ch, int startIndex)` Deprecated. Searches the string builder to find the last reference to the specified char.
`int` `lastIndexOf​(java.lang.String str)` Deprecated. Searches the string builder to find the last reference to the specified string.
`int` `lastIndexOf​(java.lang.String str, int startIndex)` Deprecated. Searches the string builder to find the last reference to the specified string starting searching from the given index.
`int` `lastIndexOf​(StrMatcher matcher)` Deprecated. Searches the string builder using the matcher to find the last match.
`int` `lastIndexOf​(StrMatcher matcher, int startIndex)` Deprecated. Searches the string builder using the matcher to find the last match searching from the given index.
`java.lang.String` `leftString​(int length)` Deprecated. Extracts the leftmost characters from the string builder without throwing an exception.
`int` `length()` Deprecated. Gets the length of the string builder.
`java.lang.String` `midString​(int index, int length)` Deprecated. Extracts some characters from the middle of the string builder without throwing an exception.
`StrBuilder` `minimizeCapacity()` Deprecated. Minimizes the capacity to the actual length of the string.
`int` `readFrom​(java.lang.Readable readable)` Deprecated. If possible, reads chars from the provided `Readable` directly into underlying character buffer without making extra copies.
`StrBuilder` `replace​(int startIndex, int endIndex, java.lang.String replaceStr)` Deprecated. Replaces a portion of the string builder with another string.
`StrBuilder` `replace​(StrMatcher matcher, java.lang.String replaceStr, int startIndex, int endIndex, int replaceCount)` Deprecated. Advanced search and replaces within the builder using a matcher.
`StrBuilder` `replaceAll​(char search, char replace)` Deprecated. Replaces the search character with the replace character throughout the builder.
`StrBuilder` `replaceAll​(java.lang.String searchStr, java.lang.String replaceStr)` Deprecated. Replaces the search string with the replace string throughout the builder.
`StrBuilder` `replaceAll​(StrMatcher matcher, java.lang.String replaceStr)` Deprecated. Replaces all matches within the builder with the replace string.
`StrBuilder` `replaceFirst​(char search, char replace)` Deprecated. Replaces the first instance of the search character with the replace character in the builder.
`StrBuilder` `replaceFirst​(java.lang.String searchStr, java.lang.String replaceStr)` Deprecated. Replaces the first instance of the search string with the replace string.
`StrBuilder` `replaceFirst​(StrMatcher matcher, java.lang.String replaceStr)` Deprecated. Replaces the first match within the builder with the replace string.
`StrBuilder` `reverse()` Deprecated. Reverses the string builder placing each character in the opposite index.
`java.lang.String` `rightString​(int length)` Deprecated. Extracts the rightmost characters from the string builder without throwing an exception.
`StrBuilder` `setCharAt​(int index, char ch)` Deprecated. Sets the character at the specified index.
`StrBuilder` `setLength​(int length)` Deprecated. Updates the length of the builder by either dropping the last characters or adding filler of Unicode zero.
`StrBuilder` `setNewLineText​(java.lang.String newLine)` Deprecated. Sets the text to be appended when a new line is added.
`StrBuilder` `setNullText​(java.lang.String nullText)` Deprecated. Sets the text to be appended when null is added.
`int` `size()` Deprecated. Gets the length of the string builder.
`boolean` `startsWith​(java.lang.String str)` Deprecated. Checks whether this builder starts with the specified string.
`java.lang.CharSequence` `subSequence​(int startIndex, int endIndex)` Deprecated.
`java.lang.String` `substring​(int start)` Deprecated. Extracts a portion of this string builder as a string.
`java.lang.String` `substring​(int startIndex, int endIndex)` Deprecated. Extracts a portion of this string builder as a string.
`char[]` `toCharArray()` Deprecated. Copies the builder's character array into a new character array.
`char[]` `toCharArray​(int startIndex, int endIndex)` Deprecated. Copies part of the builder's character array into a new character array.
`java.lang.String` `toString()` Deprecated. Gets a String version of the string builder, creating a new instance each time the method is called.
`java.lang.StringBuffer` `toStringBuffer()` Deprecated. Gets a StringBuffer version of the string builder, creating a new instance each time the method is called.
`java.lang.StringBuilder` `toStringBuilder()` Deprecated. Gets a StringBuilder version of the string builder, creating a new instance each time the method is called.
`StrBuilder` `trim()` Deprecated. Trims the builder by removing characters less than or equal to a space from the beginning and end.
`protected void` `validateIndex​(int index)` Deprecated. Validates parameters defining a single index in the builder.
`protected int` `validateRange​(int startIndex, int endIndex)` Deprecated. Validates parameters defining a range of the builder.

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface java.lang.CharSequence

`chars, codePoints`

### Field Detail

#### buffer

    protected char[] buffer

Deprecated.
Internal data storage.

#### size

    protected int size

Deprecated.
Current size of the buffer.

### Constructor Detail

#### StrBuilder

    public StrBuilder()

Deprecated.
Constructor that creates an empty builder initial capacity 32 characters.

#### StrBuilder

    public StrBuilder​(int initialCapacity)

Deprecated.
Constructor that creates an empty builder the specified initial capacity.

Parameters:
  `initialCapacity` - the initial capacity, zero or less will be converted to 32

#### StrBuilder

    public StrBuilder​(java.lang.String str)

Deprecated.
Constructor that creates a builder from the string, allocating 32 extra characters for growth.

Parameters:
  `str` - the string to copy, null treated as blank string

### Method Detail

#### getNewLineText

    public java.lang.String getNewLineText()

Deprecated.
Gets the text to be appended when a new line is added.

Returns:
  the new line text, null means use system default

#### setNewLineText

    public StrBuilder setNewLineText​(java.lang.String newLine)

Deprecated.
Sets the text to be appended when a new line is added.

Parameters:
  `newLine` - the new line text, null means use system default
Returns:
  this, to enable chaining

#### getNullText

    public java.lang.String getNullText()

Deprecated.
Gets the text to be appended when null is added.

Returns:
  the null text, null means no append

#### setNullText

    public StrBuilder setNullText​(java.lang.String nullText)

Deprecated.
Sets the text to be appended when null is added.

Parameters:
  `nullText` - the null text, null means no append
Returns:
  this, to enable chaining

#### length

    public int length()

Deprecated.
Gets the length of the string builder.

Specified by:
  `length` in interface `java.lang.CharSequence`
Returns:
  the length

#### setLength

    public StrBuilder setLength​(int length)

Deprecated.
Updates the length of the builder by either dropping the last characters or adding filler of Unicode zero.

Parameters:
  `length` - the length to set to, must be zero or positive
Returns:
  this, to enable chaining
Throws:
  `java.lang.IndexOutOfBoundsException` - if the length is negative

#### capacity

    public int capacity()

Deprecated.
Gets the current size of the internal character array buffer.

Returns:
  the capacity

#### ensureCapacity

    public StrBuilder ensureCapacity​(int capacity)

Deprecated.
Checks the capacity and ensures that it is at least the size specified.

Parameters:
  `capacity` - the capacity to ensure
Returns:
  this, to enable chaining

#### minimizeCapacity

    public StrBuilder minimizeCapacity()

Deprecated.
Minimizes the capacity to the actual length of the string.

Returns:
  this, to enable chaining

#### size

    public int size()

Deprecated.
Gets the length of the string builder.

This method is the same as `length()` and is provided to match the API of Collections.

Returns:
  the length

#### isEmpty

    public boolean isEmpty()

Deprecated.
Checks is the string builder is empty (convenience Collections API style method).

This method is the same as checking `length()` and is provided to match the API of Collections.

Returns:
  `true` if the size is `0`.

#### clear

    public StrBuilder clear()

Deprecated.
Clears the string builder (convenience Collections API style method).

This method does not reduce the size of the internal character buffer. To do that, call `clear()` followed by `minimizeCapacity()`.

This method is the same as `setLength(int)` called with zero and is provided to match the API of Collections.

Returns:
  this, to enable chaining

#### charAt

    public char charAt​(int index)

Deprecated.
Gets the character at the specified index.

Specified by:
  `charAt` in interface `java.lang.CharSequence`
Parameters:
  `index` - the index to retrieve, must be valid
Returns:
  the character at the index
Throws:
  `java.lang.IndexOutOfBoundsException` - if the index is invalid
See Also:
  `setCharAt(int, char)`, `deleteCharAt(int)`

#### setCharAt

    public StrBuilder setCharAt​(int index,
                                char ch)

Deprecated.
Sets the character at the specified index.

Parameters:
  `index` - the index to set
  `ch` - the new character
Returns:
  this, to enable chaining
Throws:
  `java.lang.IndexOutOfBoundsException` - if the index is invalid
See Also:
  `charAt(int)`, `deleteCharAt(int)`

#### deleteCharAt

    public StrBuilder deleteCharAt​(int index)

Deprecated.
Deletes the character at the specified index.

Parameters:
  `index` - the index to delete
Returns:
  this, to enable chaining
Throws:
  `java.lang.IndexOutOfBoundsException` - if the index is invalid
See Also:
  `charAt(int)`, `setCharAt(int, char)`

#### toCharArray

    public char[] toCharArray()

Deprecated.
Copies the builder's character array into a new character array.

Returns:
  a new array that represents the contents of the builder

#### toCharArray

    public char[] toCharArray​(int startIndex,
                              int endIndex)

Deprecated.
Copies part of the builder's character array into a new character array.

Parameters:
  `startIndex` - the start index, inclusive, must be valid
  `endIndex` - the end index, exclusive, must be valid except that if too large it is treated as end of string
Returns:
  a new array that holds part of the contents of the builder
Throws:
  `java.lang.IndexOutOfBoundsException` - if startIndex is invalid, or if endIndex is invalid (but endIndex greater than size is valid)

#### getChars

    public char[] getChars​(char[] destination)

Deprecated.
Copies the character array into the specified array.

Parameters:
  `destination` - the destination array, null will cause an array to be created
Returns:
  the input array, unless that was null or too small

#### getChars

    public void getChars​(int startIndex,
                         int endIndex,
                         char[] destination,
                         int destinationIndex)

Deprecated.
Copies the character array into the specified array.

Parameters:
  `startIndex` - first index to copy, inclusive, must be valid
  `endIndex` - last index, exclusive, must be valid
  `destination` - the destination array, must not be null or too small
  `destinationIndex` - the index to start copying in destination
Throws:
  `java.lang.NullPointerException` - if the array is null
  `java.lang.IndexOutOfBoundsException` - if any index is invalid

#### readFrom

    public int readFrom​(java.lang.Readable readable)
                 throws java.io.IOException

Deprecated.
If possible, reads chars from the provided `Readable` directly into underlying character buffer without making extra copies.

Parameters:
  `readable` - object to read from
Returns:
  the number of characters read
Throws:
  `java.io.IOException` - if an I/O error occurs
Since:
  3.4
See Also:
  `appendTo(Appendable)`

#### appendNewLine

    public StrBuilder appendNewLine()

Deprecated.
Appends the new line string to this string builder.

The new line string can be altered using `setNewLineText(String)`. This might be used to force the output to always use Unix line endings even when on Windows.

Returns:
  this, to enable chaining

#### appendNull

    public StrBuilder appendNull()

Deprecated.
Appends the text representing `null` to this string builder.

Returns:
  this, to enable chaining

#### append

    public StrBuilder append​(java.lang.Object obj)

Deprecated.
Appends an object to this string builder. Appending null will call `appendNull()`.

Parameters:
  `obj` - the object to append
Returns:
  this, to enable chaining

#### append

    public StrBuilder append​(java.lang.CharSequence seq)

Deprecated.
Appends a CharSequence to this string builder. Appending null will call `appendNull()`.

Specified by:
  `append` in interface `java.lang.Appendable`
Parameters:
  `seq` - the CharSequence to append
Returns:
  this, to enable chaining
Since:
  3.0

#### append

    public StrBuilder append​(java.lang.CharSequence seq,
                             int startIndex,
                             int length)

Deprecated.
Appends part of a CharSequence to this string builder. Appending null will call `appendNull()`.

Specified by:
  `append` in interface `java.lang.Appendable`
Parameters:
  `seq` - the CharSequence to append
  `startIndex` - the start index, inclusive, must be valid
  `length` - the length to append, must be valid
Returns:
  this, to enable chaining
Since:
  3.0

#### append

    public StrBuilder append​(java.lang.String str)

Deprecated.
Appends a string to this string builder. Appending null will call `appendNull()`.

Parameters:
  `str` - the string to append
Returns:
  this, to enable chaining

#### append

    public StrBuilder append​(java.lang.String str,
                             int startIndex,
                             int length)

Deprecated.
Appends part of a string to this string builder. Appending null will call `appendNull()`.

Parameters:
  `str` - the string to append
  `startIndex` - the start index, inclusive, must be valid
  `length` - the length to append, must be valid
Returns:
  this, to enable chaining

#### append

    public StrBuilder append​(java.lang.String format,
                             java.lang.Object... objs)

Deprecated.
Calls `String.format(String, Object...)` and appends the result.

Parameters:
  `format` - the format string
  `objs` - the objects to use in the format string
Returns:
  `this` to enable chaining
Since:
  3.2
See Also:
  `String.format(String, Object...)`

#### append

    public StrBuilder append​(java.nio.CharBuffer buf)

Deprecated.
Appends the contents of a char buffer to this string builder. Appending null will call `appendNull()`.

Parameters:
  `buf` - the char buffer to append
Returns:
  this, to enable chaining
Since:
  3.4

#### append

    public StrBuilder append​(java.nio.CharBuffer buf,
                             int startIndex,
                             int length)

Deprecated.
Appends the contents of a char buffer to this string builder. Appending null will call `appendNull()`.

Parameters:
  `buf` - the char buffer to append
  `startIndex` - the start index, inclusive, must be valid
  `length` - the length to append, must be valid
Returns:
  this, to enable chaining
Since:
  3.4

#### append

    public StrBuilder append​(java.lang.StringBuffer str)

Deprecated.
Appends a string buffer to this string builder. Appending null will call `appendNull()`.

Parameters:
  `str` - the string buffer to append
Returns:
  this, to enable chaining

#### append

    public StrBuilder append​(java.lang.StringBuffer str,
                             int startIndex,
                             int length)

Deprecated.
Appends part of a string buffer to this string builder. Appending null will call `appendNull()`.

Parameters:
  `str` - the string to append
  `startIndex` - the start index, inclusive, must be valid
  `length` - the length to append, must be valid
Returns:
  this, to enable chaining

#### append

    public StrBuilder append​(java.lang.StringBuilder str)

Deprecated.
Appends a StringBuilder to this string builder. Appending null will call `appendNull()`.

Parameters:
  `str` - the StringBuilder to append
Returns:
  this, to enable chaining
Since:
  3.2

#### append

    public StrBuilder append​(java.lang.StringBuilder str,
                             int startIndex,
                             int length)

Deprecated.
Appends part of a StringBuilder to this string builder. Appending null will call `appendNull()`.

Parameters:
  `str` - the StringBuilder to append
  `startIndex` - the start index, inclusive, must be valid
  `length` - the length to append, must be valid
Returns:
  this, to enable chaining
Since:
  3.2

#### append

    public StrBuilder append​(StrBuilder str)

Deprecated.
Appends another string builder to this string builder. Appending null will call `appendNull()`.

Parameters:
  `str` - the string builder to append
Returns:
  this, to enable chaining

#### append

    public StrBuilder append​(StrBuilder str,
                             int startIndex,
                             int length)

Deprecated.
Appends part of a string builder to this string builder. Appending null will call `appendNull()`.

Parameters:
  `str` - the string to append
  `startIndex` - the start index, inclusive, must be valid
  `length` - the length to append, must be valid
Returns:
  this, to enable chaining

#### append

    public StrBuilder append​(char[] chars)

Deprecated.
Appends a char array to the string builder. Appending null will call `appendNull()`.

Parameters:
  `chars` - the char array to append
Returns:
  this, to enable chaining

#### append

    public StrBuilder append​(char[] chars,
                             int startIndex,
                             int length)

Deprecated.
Appends a char array to the string builder. Appending null will call `appendNull()`.

Parameters:
  `chars` - the char array to append
  `startIndex` - the start index, inclusive, must be valid
  `length` - the length to append, must be valid
Returns:
  this, to enable chaining

#### append

    public StrBuilder append​(boolean value)

Deprecated.
Appends a boolean value to the string builder.

Parameters:
  `value` - the value to append
Returns:
  this, to enable chaining

#### append

    public StrBuilder append​(char ch)

Deprecated.
Appends a char value to the string builder.

Specified by:
  `append` in interface `java.lang.Appendable`
Parameters:
  `ch` - the value to append
Returns:
  this, to enable chaining
Since:
  3.0

#### append

    public StrBuilder append​(int value)

Deprecated.
Appends an int value to the string builder using `String.valueOf`.

Parameters:
  `value` - the value to append
Returns:
  this, to enable chaining

#### append

    public StrBuilder append​(long value)

Deprecated.
Appends a long value to the string builder using `String.valueOf`.

Parameters:
  `value` - the value to append
Returns:
  this, to enable chaining

#### append

    public StrBuilder append​(float value)

Deprecated.
Appends a float value to the string builder using `String.valueOf`.

Parameters:
  `value` - the value to append
Returns:
  this, to enable chaining

#### append

    public StrBuilder append​(double value)

Deprecated.
Appends a double value to the string builder using `String.valueOf`.

Parameters:
  `value` - the value to append
Returns:
  this, to enable chaining

#### appendln

    public StrBuilder appendln​(java.lang.Object obj)

Deprecated.
Appends an object followed by a new line to this string builder. Appending null will call `appendNull()`.

Parameters:
  `obj` - the object to append
Returns:
  this, to enable chaining
Since:
  2.3

#### appendln

    public StrBuilder appendln​(java.lang.String str)

Deprecated.
Appends a string followed by a new line to this string builder. Appending null will call `appendNull()`.

Parameters:
  `str` - the string to append
Returns:
  this, to enable chaining
Since:
  2.3

#### appendln

    public StrBuilder appendln​(java.lang.String str,
                               int startIndex,
                               int length)

Deprecated.
Appends part of a string followed by a new line to this string builder. Appending null will call `appendNull()`.

Parameters:
  `str` - the string to append
  `startIndex` - the start index, inclusive, must be valid
  `length` - the length to append, must be valid
Returns:
  this, to enable chaining
Since:
  2.3

#### appendln

    public StrBuilder appendln​(java.lang.String format,
                               java.lang.Object... objs)

Deprecated.
Calls `String.format(String, Object...)` and appends the result.

Parameters:
  `format` - the format string
  `objs` - the objects to use in the format string
Returns:
  `this` to enable chaining
Since:
  3.2
See Also:
  `String.format(String, Object...)`

#### appendln

    public StrBuilder appendln​(java.lang.StringBuffer str)

Deprecated.
Appends a string buffer followed by a new line to this string builder. Appending null will call `appendNull()`.

Parameters:
  `str` - the string buffer to append
Returns:
  this, to enable chaining
Since:
  2.3

#### appendln

    public StrBuilder appendln​(java.lang.StringBuilder str)

Deprecated.
Appends a string builder followed by a new line to this string builder. Appending null will call `appendNull()`.

Parameters:
  `str` - the string builder to append
Returns:
  this, to enable chaining
Since:
  3.2

#### appendln

    public StrBuilder appendln​(java.lang.StringBuilder str,
                               int startIndex,
                               int length)

Deprecated.
Appends part of a string builder followed by a new line to this string builder. Appending null will call `appendNull()`.

Parameters:
  `str` - the string builder to append
  `startIndex` - the start index, inclusive, must be valid
  `length` - the length to append, must be valid
Returns:
  this, to enable chaining
Since:
  3.2

#### appendln

    public StrBuilder appendln​(java.lang.StringBuffer str,
                               int startIndex,
                               int length)

Deprecated.
Appends part of a string buffer followed by a new line to this string builder. Appending null will call `appendNull()`.

Parameters:
  `str` - the string to append
  `startIndex` - the start index, inclusive, must be valid
  `length` - the length to append, must be valid
Returns:
  this, to enable chaining
Since:
  2.3

#### appendln

    public StrBuilder appendln​(StrBuilder str)

Deprecated.
Appends another string builder followed by a new line to this string builder. Appending null will call `appendNull()`.

Parameters:
  `str` - the string builder to append
Returns:
  this, to enable chaining
Since:
  2.3

#### appendln

    public StrBuilder appendln​(StrBuilder str,
                               int startIndex,
                               int length)

Deprecated.
Appends part of a string builder followed by a new line to this string builder. Appending null will call `appendNull()`.

Parameters:
  `str` - the string to append
  `startIndex` - the start index, inclusive, must be valid
  `length` - the length to append, must be valid
Returns:
  this, to enable chaining
Since:
  2.3

#### appendln

    public StrBuilder appendln​(char[] chars)

Deprecated.
Appends a char array followed by a new line to the string builder. Appending null will call `appendNull()`.

Parameters:
  `chars` - the char array to append
Returns:
  this, to enable chaining
Since:
  2.3

#### appendln

    public StrBuilder appendln​(char[] chars,
                               int startIndex,
                               int length)

Deprecated.
Appends a char array followed by a new line to the string builder. Appending null will call `appendNull()`.

Parameters:
  `chars` - the char array to append
  `startIndex` - the start index, inclusive, must be valid
  `length` - the length to append, must be valid
Returns:
  this, to enable chaining
Since:
  2.3

#### appendln

    public StrBuilder appendln​(boolean value)

Deprecated.
Appends a boolean value followed by a new line to the string builder.

Parameters:
  `value` - the value to append
Returns:
  this, to enable chaining
Since:
  2.3

#### appendln

    public StrBuilder appendln​(char ch)

Deprecated.
Appends a char value followed by a new line to the string builder.

Parameters:
  `ch` - the value to append
Returns:
  this, to enable chaining
Since:
  2.3

#### appendln

    public StrBuilder appendln​(int value)

Deprecated.
Appends an int value followed by a new line to the string builder using `String.valueOf`.

Parameters:
  `value` - the value to append
Returns:
  this, to enable chaining
Since:
  2.3

#### appendln

    public StrBuilder appendln​(long value)

Deprecated.
Appends a long value followed by a new line to the string builder using `String.valueOf`.

Parameters:
  `value` - the value to append
Returns:
  this, to enable chaining
Since:
  2.3

#### appendln

    public StrBuilder appendln​(float value)

Deprecated.
Appends a float value followed by a new line to the string builder using `String.valueOf`.

Parameters:
  `value` - the value to append
Returns:
  this, to enable chaining
Since:
  2.3

#### appendln

    public StrBuilder appendln​(double value)

Deprecated.
Appends a double value followed by a new line to the string builder using `String.valueOf`.

Parameters:
  `value` - the value to append
Returns:
  this, to enable chaining
Since:
  2.3

#### appendAll

    public <T> StrBuilder appendAll​(T... array)

Deprecated.
Appends each item in an array to the builder without any separators. Appending a null array will have no effect. Each object is appended using `append(Object)`.

Type Parameters:
  `T` - the element type
Parameters:
  `array` - the array to append
Returns:
  this, to enable chaining
Since:
  2.3

#### appendAll

    public StrBuilder appendAll​(java.lang.Iterable<?> iterable)

Deprecated.
Appends each item in an iterable to the builder without any separators. Appending a null iterable will have no effect. Each object is appended using `append(Object)`.

Parameters:
  `iterable` - the iterable to append
Returns:
  this, to enable chaining
Since:
  2.3

#### appendAll

    public StrBuilder appendAll​(java.util.Iterator<?> it)

Deprecated.
Appends each item in an iterator to the builder without any separators. Appending a null iterator will have no effect. Each object is appended using `append(Object)`.

Parameters:
  `it` - the iterator to append
Returns:
  this, to enable chaining
Since:
  2.3

#### appendWithSeparators

    public StrBuilder appendWithSeparators​(java.lang.Object[] array,
                                           java.lang.String separator)

Deprecated.
Appends an array placing separators between each value, but not before the first or after the last. Appending a null array will have no effect. Each object is appended using `append(Object)`.

Parameters:
  `array` - the array to append
  `separator` - the separator to use, null means no separator
Returns:
  this, to enable chaining

#### appendWithSeparators

    public StrBuilder appendWithSeparators​(java.lang.Iterable<?> iterable,
                                           java.lang.String separator)

Deprecated.
Appends an iterable placing separators between each value, but not before the first or after the last. Appending a null iterable will have no effect. Each object is appended using `append(Object)`.

Parameters:
  `iterable` - the iterable to append
  `separator` - the separator to use, null means no separator
Returns:
  this, to enable chaining

#### appendWithSeparators

    public StrBuilder appendWithSeparators​(java.util.Iterator<?> it,
                                           java.lang.String separator)

Deprecated.
Appends an iterator placing separators between each value, but not before the first or after the last. Appending a null iterator will have no effect. Each object is appended using `append(Object)`.

Parameters:
  `it` - the iterator to append
  `separator` - the separator to use, null means no separator
Returns:
  this, to enable chaining

#### appendSeparator

    public StrBuilder appendSeparator​(java.lang.String separator)

Deprecated.
Appends a separator if the builder is currently non-empty. Appending a null separator will have no effect. The separator is appended using `append(String)`.

This method is useful for adding a separator each time around the loop except the first.

     for (Iterator it = list.iterator(); it.hasNext(); ) {
       appendSeparator(",");
       append(it.next());
     }

Note that for this simple example, you should use `appendWithSeparators(Iterable, String)`.

Parameters:
  `separator` - the separator to use, null means no separator
Returns:
  this, to enable chaining
Since:
  2.3

#### appendSeparator

    public StrBuilder appendSeparator​(java.lang.String standard,
                                      java.lang.String defaultIfEmpty)

Deprecated.
Appends one of both separators to the StrBuilder. If the builder is currently empty it will append the defaultIfEmpty-separator Otherwise it will append the standard-separator Appending a null separator will have no effect. The separator is appended using `append(String)`.

This method is for example useful for constructing queries

     StrBuilder whereClause = new StrBuilder();
     if (searchCommand.getPriority() != null) {
      whereClause.appendSeparator(" and", " where");
      whereClause.append(" priority = ?")
     }
     if (searchCommand.getComponent() != null) {
      whereClause.appendSeparator(" and", " where");
      whereClause.append(" component = ?")
     }
     selectClause.append(whereClause)

Parameters:
  `standard` - the separator if builder is not empty, null means no separator
  `defaultIfEmpty` - the separator if builder is empty, null means no separator
Returns:
  this, to enable chaining
Since:
  2.5

#### appendSeparator

    public StrBuilder appendSeparator​(char separator)

Deprecated.
Appends a separator if the builder is currently non-empty. The separator is appended using `append(char)`.

This method is useful for adding a separator each time around the loop except the first.

     for (Iterator it = list.iterator(); it.hasNext(); ) {
       appendSeparator(',');
       append(it.next());
     }

Note that for this simple example, you should use `appendWithSeparators(Iterable, String)`.

Parameters:
  `separator` - the separator to use
Returns:
  this, to enable chaining
Since:
  2.3

#### appendSeparator

    public StrBuilder appendSeparator​(char standard,
                                      char defaultIfEmpty)

Deprecated.
Append one of both separators to the builder If the builder is currently empty it will append the defaultIfEmpty-separator Otherwise it will append the standard-separator The separator is appended using `append(char)`.

Parameters:
  `standard` - the separator if builder is not empty
  `defaultIfEmpty` - the separator if builder is empty
Returns:
  this, to enable chaining
Since:
  2.5

#### appendSeparator

    public StrBuilder appendSeparator​(java.lang.String separator,
                                      int loopIndex)

Deprecated.
Appends a separator to the builder if the loop index is greater than zero. Appending a null separator will have no effect. The separator is appended using `append(String)`.

This method is useful for adding a separator each time around the loop except the first.

     for (int i = 0; i < list.size(); i++) {
       appendSeparator(",", i);
       append(list.get(i));
     }

Note that for this simple example, you should use `appendWithSeparators(Iterable, String)`.

Parameters:
  `separator` - the separator to use, null means no separator
  `loopIndex` - the loop index
Returns:
  this, to enable chaining
Since:
  2.3

#### appendSeparator

    public StrBuilder appendSeparator​(char separator,
                                      int loopIndex)

Deprecated.
Appends a separator to the builder if the loop index is greater than zero. The separator is appended using `append(char)`.

This method is useful for adding a separator each time around the loop except the first.

     for (int i = 0; i < list.size(); i++) {
       appendSeparator(",", i);
       append(list.get(i));
     }

Note that for this simple example, you should use `appendWithSeparators(Iterable, String)`.

Parameters:
  `separator` - the separator to use
  `loopIndex` - the loop index
Returns:
  this, to enable chaining
Since:
  2.3

#### appendPadding

    public StrBuilder appendPadding​(int length,
                                    char padChar)

Deprecated.
Appends the pad character to the builder the specified number of times.

Parameters:
  `length` - the length to append, negative means no append
  `padChar` - the character to append
Returns:
  this, to enable chaining

#### appendFixedWidthPadLeft

    public StrBuilder appendFixedWidthPadLeft​(java.lang.Object obj,
                                              int width,
                                              char padChar)

Deprecated.
Appends an object to the builder padding on the left to a fixed width. The `toString` of the object is used. If the object is larger than the length, the left hand side is lost. If the object is null, the null text value is used.

Parameters:
  `obj` - the object to append, null uses null text
  `width` - the fixed field width, zero or negative has no effect
  `padChar` - the pad character to use
Returns:
  this, to enable chaining

#### appendFixedWidthPadLeft

    public StrBuilder appendFixedWidthPadLeft​(int value,
                                              int width,
                                              char padChar)

Deprecated.
Appends an object to the builder padding on the left to a fixed width. The `String.valueOf` of the `int` value is used. If the formatted value is larger than the length, the left hand side is lost.

Parameters:
  `value` - the value to append
  `width` - the fixed field width, zero or negative has no effect
  `padChar` - the pad character to use
Returns:
  this, to enable chaining

#### appendFixedWidthPadRight

    public StrBuilder appendFixedWidthPadRight​(java.lang.Object obj,
                                               int width,
                                               char padChar)

Deprecated.
Appends an object to the builder padding on the right to a fixed length. The `toString` of the object is used. If the object is larger than the length, the right hand side is lost. If the object is null, null text value is used.

Parameters:
  `obj` - the object to append, null uses null text
  `width` - the fixed field width, zero or negative has no effect
  `padChar` - the pad character to use
Returns:
  this, to enable chaining

#### appendFixedWidthPadRight

    public StrBuilder appendFixedWidthPadRight​(int value,
                                               int width,
                                               char padChar)

Deprecated.
Appends an object to the builder padding on the right to a fixed length. The `String.valueOf` of the `int` value is used. If the object is larger than the length, the right hand side is lost.

Parameters:
  `value` - the value to append
  `width` - the fixed field width, zero or negative has no effect
  `padChar` - the pad character to use
Returns:
  this, to enable chaining

#### insert

    public StrBuilder insert​(int index,
                             java.lang.Object obj)

Deprecated.
Inserts the string representation of an object into this builder. Inserting null will use the stored null text value.

Parameters:
  `index` - the index to add at, must be valid
  `obj` - the object to insert
Returns:
  this, to enable chaining
Throws:
  `java.lang.IndexOutOfBoundsException` - if the index is invalid

#### insert

    public StrBuilder insert​(int index,
                             java.lang.String str)

Deprecated.
Inserts the string into this builder. Inserting null will use the stored null text value.

Parameters:
  `index` - the index to add at, must be valid
  `str` - the string to insert
Returns:
  this, to enable chaining
Throws:
  `java.lang.IndexOutOfBoundsException` - if the index is invalid

#### insert

    public StrBuilder insert​(int index,
                             char[] chars)

Deprecated.
Inserts the character array into this builder. Inserting null will use the stored null text value.

Parameters:
  `index` - the index to add at, must be valid
  `chars` - the char array to insert
Returns:
  this, to enable chaining
Throws:
  `java.lang.IndexOutOfBoundsException` - if the index is invalid

#### insert

    public StrBuilder insert​(int index,
                             char[] chars,
                             int offset,
                             int length)

Deprecated.
Inserts part of the character array into this builder. Inserting null will use the stored null text value.

Parameters:
  `index` - the index to add at, must be valid
  `chars` - the char array to insert
  `offset` - the offset into the character array to start at, must be valid
  `length` - the length of the character array part to copy, must be positive
Returns:
  this, to enable chaining
Throws:
  `java.lang.IndexOutOfBoundsException` - if any index is invalid

#### insert

    public StrBuilder insert​(int index,
                             boolean value)

Deprecated.
Inserts the value into this builder.

Parameters:
  `index` - the index to add at, must be valid
  `value` - the value to insert
Returns:
  this, to enable chaining
Throws:
  `java.lang.IndexOutOfBoundsException` - if the index is invalid

#### insert

    public StrBuilder insert​(int index,
                             char value)

Deprecated.
Inserts the value into this builder.

Parameters:
  `index` - the index to add at, must be valid
  `value` - the value to insert
Returns:
  this, to enable chaining
Throws:
  `java.lang.IndexOutOfBoundsException` - if the index is invalid

#### insert

    public StrBuilder insert​(int index,
                             int value)

Deprecated.
Inserts the value into this builder.

Parameters:
  `index` - the index to add at, must be valid
  `value` - the value to insert
Returns:
  this, to enable chaining
Throws:
  `java.lang.IndexOutOfBoundsException` - if the index is invalid

#### insert

    public StrBuilder insert​(int index,
                             long value)

Deprecated.
Inserts the value into this builder.

Parameters:
  `index` - the index to add at, must be valid
  `value` - the value to insert
Returns:
  this, to enable chaining
Throws:
  `java.lang.IndexOutOfBoundsException` - if the index is invalid

#### insert

    public StrBuilder insert​(int index,
                             float value)

Deprecated.
Inserts the value into this builder.

Parameters:
  `index` - the index to add at, must be valid
  `value` - the value to insert
Returns:
  this, to enable chaining
Throws:
  `java.lang.IndexOutOfBoundsException` - if the index is invalid

#### insert

    public StrBuilder insert​(int index,
                             double value)

Deprecated.
Inserts the value into this builder.

Parameters:
  `index` - the index to add at, must be valid
  `value` - the value to insert
Returns:
  this, to enable chaining
Throws:
  `java.lang.IndexOutOfBoundsException` - if the index is invalid

#### delete

    public StrBuilder delete​(int startIndex,
                             int endIndex)

Deprecated.
Deletes the characters between the two specified indices.

Parameters:
  `startIndex` - the start index, inclusive, must be valid
  `endIndex` - the end index, exclusive, must be valid except that if too large it is treated as end of string
Returns:
  this, to enable chaining
Throws:
  `java.lang.IndexOutOfBoundsException` - if the index is invalid

#### deleteAll

    public StrBuilder deleteAll​(char ch)

Deprecated.
Deletes the character wherever it occurs in the builder.

Parameters:
  `ch` - the character to delete
Returns:
  this, to enable chaining

#### deleteFirst

    public StrBuilder deleteFirst​(char ch)

Deprecated.
Deletes the character wherever it occurs in the builder.

Parameters:
  `ch` - the character to delete
Returns:
  this, to enable chaining

#### deleteAll

    public StrBuilder deleteAll​(java.lang.String str)

Deprecated.
Deletes the string wherever it occurs in the builder.

Parameters:
  `str` - the string to delete, null causes no action
Returns:
  this, to enable chaining

#### deleteFirst

    public StrBuilder deleteFirst​(java.lang.String str)

Deprecated.
Deletes the string wherever it occurs in the builder.

Parameters:
  `str` - the string to delete, null causes no action
Returns:
  this, to enable chaining

#### deleteAll

    public StrBuilder deleteAll​(StrMatcher matcher)

Deprecated.
Deletes all parts of the builder that the matcher matches.

Matchers can be used to perform advanced deletion behavior. For example you could write a matcher to delete all occurrences where the character 'a' is followed by a number.

Parameters:
  `matcher` - the matcher to use to find the deletion, null causes no action
Returns:
  this, to enable chaining

#### deleteFirst

    public StrBuilder deleteFirst​(StrMatcher matcher)

Deprecated.
Deletes the first match within the builder using the specified matcher.

Matchers can be used to perform advanced deletion behavior. For example you could write a matcher to delete where the character 'a' is followed by a number.

Parameters:
  `matcher` - the matcher to use to find the deletion, null causes no action
Returns:
  this, to enable chaining

#### replace

    public StrBuilder replace​(int startIndex,
                              int endIndex,
                              java.lang.String replaceStr)

Deprecated.
Replaces a portion of the string builder with another string. The length of the inserted string does not have to match the removed length.

Parameters:
  `startIndex` - the start index, inclusive, must be valid
  `endIndex` - the end index, exclusive, must be valid except that if too large it is treated as end of string
  `replaceStr` - the string to replace with, null means delete range
Returns:
  this, to enable chaining
Throws:
  `java.lang.IndexOutOfBoundsException` - if the index is invalid

#### replaceAll

    public StrBuilder replaceAll​(char search,
                                 char replace)

Deprecated.
Replaces the search character with the replace character throughout the builder.

Parameters:
  `search` - the search character
  `replace` - the replace character
Returns:
  this, to enable chaining

#### replaceFirst

    public StrBuilder replaceFirst​(char search,
                                   char replace)

Deprecated.
Replaces the first instance of the search character with the replace character in the builder.

Parameters:
  `search` - the search character
  `replace` - the replace character
Returns:
  this, to enable chaining

#### replaceAll

    public StrBuilder replaceAll​(java.lang.String searchStr,
                                 java.lang.String replaceStr)

Deprecated.
Replaces the search string with the replace string throughout the builder.

Parameters:
  `searchStr` - the search string, null causes no action to occur
  `replaceStr` - the replace string, null is equivalent to an empty string
Returns:
  this, to enable chaining

#### replaceFirst

    public StrBuilder replaceFirst​(java.lang.String searchStr,
                                   java.lang.String replaceStr)

Deprecated.
Replaces the first instance of the search string with the replace string.

Parameters:
  `searchStr` - the search string, null causes no action to occur
  `replaceStr` - the replace string, null is equivalent to an empty string
Returns:
  this, to enable chaining

#### replaceAll

    public StrBuilder replaceAll​(StrMatcher matcher,
                                 java.lang.String replaceStr)

Deprecated.
Replaces all matches within the builder with the replace string.

Matchers can be used to perform advanced replace behavior. For example you could write a matcher to replace all occurrences where the character 'a' is followed by a number.

Parameters:
  `matcher` - the matcher to use to find the deletion, null causes no action
  `replaceStr` - the replace string, null is equivalent to an empty string
Returns:
  this, to enable chaining

#### replaceFirst

    public StrBuilder replaceFirst​(StrMatcher matcher,
                                   java.lang.String replaceStr)

Deprecated.
Replaces the first match within the builder with the replace string.

Matchers can be used to perform advanced replace behavior. For example you could write a matcher to replace where the character 'a' is followed by a number.

Parameters:
  `matcher` - the matcher to use to find the deletion, null causes no action
  `replaceStr` - the replace string, null is equivalent to an empty string
Returns:
  this, to enable chaining

#### replace

    public StrBuilder replace​(StrMatcher matcher,
                              java.lang.String replaceStr,
                              int startIndex,
                              int endIndex,
                              int replaceCount)

Deprecated.
Advanced search and replaces within the builder using a matcher.

Matchers can be used to perform advanced behavior. For example you could write a matcher to delete all occurrences where the character 'a' is followed by a number.

Parameters:
  `matcher` - the matcher to use to find the deletion, null causes no action
  `replaceStr` - the string to replace the match with, null is a delete
  `startIndex` - the start index, inclusive, must be valid
  `endIndex` - the end index, exclusive, must be valid except that if too large it is treated as end of string
  `replaceCount` - the number of times to replace, -1 for replace all
Returns:
  this, to enable chaining
Throws:
  `java.lang.IndexOutOfBoundsException` - if start index is invalid

#### reverse

    public StrBuilder reverse()

Deprecated.
Reverses the string builder placing each character in the opposite index.

Returns:
  this, to enable chaining

#### trim

    public StrBuilder trim()

Deprecated.
Trims the builder by removing characters less than or equal to a space from the beginning and end.

Returns:
  this, to enable chaining

#### startsWith

    public boolean startsWith​(java.lang.String str)

Deprecated.
Checks whether this builder starts with the specified string.

Note that this method handles null input quietly, unlike String.

Parameters:
  `str` - the string to search for, null returns false
Returns:
  true if the builder starts with the string

#### endsWith

    public boolean endsWith​(java.lang.String str)

Deprecated.
Checks whether this builder ends with the specified string.

Note that this method handles null input quietly, unlike String.

Parameters:
  `str` - the string to search for, null returns false
Returns:
  true if the builder ends with the string

#### subSequence

    public java.lang.CharSequence subSequence​(int startIndex,
                                              int endIndex)

Deprecated.

Specified by:
  `subSequence` in interface `java.lang.CharSequence`
Since:
  3.0

#### substring

    public java.lang.String substring​(int start)

Deprecated.
Extracts a portion of this string builder as a string.

Parameters:
  `start` - the start index, inclusive, must be valid
Returns:
  the new string
Throws:
  `java.lang.IndexOutOfBoundsException` - if the index is invalid

#### substring

    public java.lang.String substring​(int startIndex,
                                      int endIndex)

Deprecated.
Extracts a portion of this string builder as a string.

Note: This method treats an endIndex greater than the length of the builder as equal to the length of the builder, and continues without error, unlike StringBuffer or String.

Parameters:
  `startIndex` - the start index, inclusive, must be valid
  `endIndex` - the end index, exclusive, must be valid except that if too large it is treated as end of string
Returns:
  the new string
Throws:
  `java.lang.IndexOutOfBoundsException` - if the index is invalid

#### leftString

    public java.lang.String leftString​(int length)

Deprecated.
Extracts the leftmost characters from the string builder without throwing an exception.

This method extracts the left `length` characters from the builder. If this many characters are not available, the whole builder is returned. Thus the returned string may be shorter than the length requested.

Parameters:
  `length` - the number of characters to extract, negative returns empty string
Returns:
  the new string

#### rightString

    public java.lang.String rightString​(int length)

Deprecated.
Extracts the rightmost characters from the string builder without throwing an exception.

This method extracts the right `length` characters from the builder. If this many characters are not available, the whole builder is returned. Thus the returned string may be shorter than the length requested.

Parameters:
  `length` - the number of characters to extract, negative returns empty string
Returns:
  the new string

#### midString

    public java.lang.String midString​(int index,
                                      int length)

Deprecated.
Extracts some characters from the middle of the string builder without throwing an exception.

This method extracts `length` characters from the builder at the specified index. If the index is negative it is treated as zero. If the index is greater than the builder size, it is treated as the builder size. If the length is negative, the empty string is returned. If insufficient characters are available in the builder, as much as possible is returned. Thus the returned string may be shorter than the length requested.

Parameters:
  `index` - the index to start at, negative means zero
  `length` - the number of characters to extract, negative returns empty string
Returns:
  the new string

#### contains

    public boolean contains​(char ch)

Deprecated.
Checks if the string builder contains the specified char.

Parameters:
  `ch` - the character to find
Returns:
  true if the builder contains the character

#### contains

    public boolean contains​(java.lang.String str)

Deprecated.
Checks if the string builder contains the specified string.

Parameters:
  `str` - the string to find
Returns:
  true if the builder contains the string

#### contains

    public boolean contains​(StrMatcher matcher)

Deprecated.
Checks if the string builder contains a string matched using the specified matcher.

Matchers can be used to perform advanced searching behavior. For example you could write a matcher to search for the character 'a' followed by a number.

Parameters:
  `matcher` - the matcher to use, null returns -1
Returns:
  true if the matcher finds a match in the builder

#### indexOf

    public int indexOf​(char ch)

Deprecated.
Searches the string builder to find the first reference to the specified char.

Parameters:
  `ch` - the character to find
Returns:
  the first index of the character, or -1 if not found

#### indexOf

    public int indexOf​(char ch,
                       int startIndex)

Deprecated.
Searches the string builder to find the first reference to the specified char.

Parameters:
  `ch` - the character to find
  `startIndex` - the index to start at, invalid index rounded to edge
Returns:
  the first index of the character, or -1 if not found

#### indexOf

    public int indexOf​(java.lang.String str)

Deprecated.
Searches the string builder to find the first reference to the specified string.

Note that a null input string will return -1, whereas the JDK throws an exception.

Parameters:
  `str` - the string to find, null returns -1
Returns:
  the first index of the string, or -1 if not found

#### indexOf

    public int indexOf​(java.lang.String str,
                       int startIndex)

Deprecated.
Searches the string builder to find the first reference to the specified string starting searching from the given index.

Note that a null input string will return -1, whereas the JDK throws an exception.

Parameters:
  `str` - the string to find, null returns -1
  `startIndex` - the index to start at, invalid index rounded to edge
Returns:
  the first index of the string, or -1 if not found

#### indexOf

    public int indexOf​(StrMatcher matcher)

Deprecated.
Searches the string builder using the matcher to find the first match.

Matchers can be used to perform advanced searching behavior. For example you could write a matcher to find the character 'a' followed by a number.

Parameters:
  `matcher` - the matcher to use, null returns -1
Returns:
  the first index matched, or -1 if not found

#### indexOf

    public int indexOf​(StrMatcher matcher,
                       int startIndex)

Deprecated.
Searches the string builder using the matcher to find the first match searching from the given index.

Matchers can be used to perform advanced searching behavior. For example you could write a matcher to find the character 'a' followed by a number.

Parameters:
  `matcher` - the matcher to use, null returns -1
  `startIndex` - the index to start at, invalid index rounded to edge
Returns:
  the first index matched, or -1 if not found

#### lastIndexOf

    public int lastIndexOf​(char ch)

Deprecated.
Searches the string builder to find the last reference to the specified char.

Parameters:
  `ch` - the character to find
Returns:
  the last index of the character, or -1 if not found

#### lastIndexOf

    public int lastIndexOf​(char ch,
                           int startIndex)

Deprecated.
Searches the string builder to find the last reference to the specified char.

Parameters:
  `ch` - the character to find
  `startIndex` - the index to start at, invalid index rounded to edge
Returns:
  the last index of the character, or -1 if not found

#### lastIndexOf

    public int lastIndexOf​(java.lang.String str)

Deprecated.
Searches the string builder to find the last reference to the specified string.

Note that a null input string will return -1, whereas the JDK throws an exception.

Parameters:
  `str` - the string to find, null returns -1
Returns:
  the last index of the string, or -1 if not found

#### lastIndexOf

    public int lastIndexOf​(java.lang.String str,
                           int startIndex)

Deprecated.
Searches the string builder to find the last reference to the specified string starting searching from the given index.

Note that a null input string will return -1, whereas the JDK throws an exception.

Parameters:
  `str` - the string to find, null returns -1
  `startIndex` - the index to start at, invalid index rounded to edge
Returns:
  the last index of the string, or -1 if not found

#### lastIndexOf

    public int lastIndexOf​(StrMatcher matcher)

Deprecated.
Searches the string builder using the matcher to find the last match.

Matchers can be used to perform advanced searching behavior. For example you could write a matcher to find the character 'a' followed by a number.

Parameters:
  `matcher` - the matcher to use, null returns -1
Returns:
  the last index matched, or -1 if not found

#### lastIndexOf

    public int lastIndexOf​(StrMatcher matcher,
                           int startIndex)

Deprecated.
Searches the string builder using the matcher to find the last match searching from the given index.

Matchers can be used to perform advanced searching behavior. For example you could write a matcher to find the character 'a' followed by a number.

Parameters:
  `matcher` - the matcher to use, null returns -1
  `startIndex` - the index to start at, invalid index rounded to edge
Returns:
  the last index matched, or -1 if not found

#### asTokenizer

    public StrTokenizer asTokenizer()

Deprecated.
Creates a tokenizer that can tokenize the contents of this builder.

This method allows the contents of this builder to be tokenized. The tokenizer will be setup by default to tokenize on space, tab, newline and formfeed (as per StringTokenizer). These values can be changed on the tokenizer class, before retrieving the tokens.

The returned tokenizer is linked to this builder. You may intermix calls to the builder and tokenizer within certain limits, however there is no synchronization. Once the tokenizer has been used once, it must be `reset` to pickup the latest changes in the builder. For example:

     StrBuilder b = new StrBuilder();
     b.append("a b ");
     StrTokenizer t = b.asTokenizer();
     String[] tokens1 = t.getTokenArray();  // returns a,b
     b.append("c d ");
     String[] tokens2 = t.getTokenArray();  // returns a,b (c and d ignored)
     t.reset();              // reset causes builder changes to be picked up
     String[] tokens3 = t.getTokenArray();  // returns a,b,c,d

In addition to simply intermixing appends and tokenization, you can also call the set methods on the tokenizer to alter how it tokenizes. Just remember to call reset when you want to pickup builder changes.

Calling `StrTokenizer.reset(String)` or `StrTokenizer.reset(char[])` with a non-null value will break the link with the builder.

Returns:
  a tokenizer that is linked to this builder

#### asReader

    public java.io.Reader asReader()

Deprecated.
Gets the contents of this builder as a Reader.

This method allows the contents of the builder to be read using any standard method that expects a Reader.

To use, simply create a `StrBuilder`, populate it with data, call `asReader`, and then read away.

The internal character array is shared between the builder and the reader. This allows you to append to the builder after creating the reader, and the changes will be picked up. Note however, that no synchronization occurs, so you must perform all operations with the builder and the reader in one thread.

The returned reader supports marking, and ignores the flush method.

Returns:
  a reader that reads from this builder

#### asWriter

    public java.io.Writer asWriter()

Deprecated.
Gets this builder as a Writer that can be written to.

This method allows you to populate the contents of the builder using any standard method that takes a Writer.

To use, simply create a `StrBuilder`, call `asWriter`, and populate away. The data is available at any time using the methods of the `StrBuilder`.

The internal character array is shared between the builder and the writer. This allows you to intermix calls that append to the builder and write using the writer and the changes will be occur correctly. Note however, that no synchronization occurs, so you must perform all operations with the builder and the writer in one thread.

The returned writer ignores the close and flush methods.

Returns:
  a writer that populates this builder

#### appendTo

    public void appendTo​(java.lang.Appendable appendable)
                  throws java.io.IOException

Deprecated.
Appends current contents of this `StrBuilder` to the provided `Appendable`.

This method tries to avoid doing any extra copies of contents.

Parameters:
  `appendable` - the appendable to append data to
Throws:
  `java.io.IOException` - if an I/O error occurs
Since:
  3.4
See Also:
  `readFrom(Readable)`

#### equalsIgnoreCase

    public boolean equalsIgnoreCase​(StrBuilder other)

Deprecated.
Checks the contents of this builder against another to see if they contain the same character content ignoring case.

Parameters:
  `other` - the object to check, null returns false
Returns:
  true if the builders contain the same characters in the same order

#### equals

    public boolean equals​(StrBuilder other)

Deprecated.
Checks the contents of this builder against another to see if they contain the same character content.

Parameters:
  `other` - the object to check, null returns false
Returns:
  true if the builders contain the same characters in the same order

#### equals

    public boolean equals​(java.lang.Object obj)

Deprecated.
Checks the contents of this builder against another to see if they contain the same character content.

Overrides:
  `equals` in class `java.lang.Object`
Parameters:
  `obj` - the object to check, null returns false
Returns:
  true if the builders contain the same characters in the same order

#### hashCode

    public int hashCode()

Deprecated.
Gets a suitable hash code for this builder.

Overrides:
  `hashCode` in class `java.lang.Object`
Returns:
  a hash code

#### toString

    public java.lang.String toString()

Deprecated.
Gets a String version of the string builder, creating a new instance each time the method is called.

Note that unlike StringBuffer, the string version returned is independent of the string builder.

Specified by:
  `toString` in interface `java.lang.CharSequence`
Overrides:
  `toString` in class `java.lang.Object`
Returns:
  the builder as a String

#### toStringBuffer

    public java.lang.StringBuffer toStringBuffer()

Deprecated.
Gets a StringBuffer version of the string builder, creating a new instance each time the method is called.

Returns:
  the builder as a StringBuffer

#### toStringBuilder

    public java.lang.StringBuilder toStringBuilder()

Deprecated.
Gets a StringBuilder version of the string builder, creating a new instance each time the method is called.

Returns:
  the builder as a StringBuilder
Since:
  3.2

#### build

    public java.lang.String build()

Deprecated.
Implement the `Builder` interface.

Specified by:
  `build` in interface `Builder<java.lang.String>`
Returns:
  the builder as a String
Since:
  3.2
See Also:
  `toString()`

#### validateRange

    protected int validateRange​(int startIndex,
                                int endIndex)

Deprecated.
Validates parameters defining a range of the builder.

Parameters:
  `startIndex` - the start index, inclusive, must be valid
  `endIndex` - the end index, exclusive, must be valid except that if too large it is treated as end of string
Returns:
  the new string
Throws:
  `java.lang.IndexOutOfBoundsException` - if the index is invalid

#### validateIndex

    protected void validateIndex​(int index)

Deprecated.
Validates parameters defining a single index in the builder.

Parameters:
  `index` - the index, must be valid
Throws:
  `java.lang.IndexOutOfBoundsException` - if the index is invalid